// Licensed to the Apache Software Foundation (ASF) under one or more
// contributor license agreements.  See the NOTICE file distributed with
// this work for additional information regarding copyright ownership.
// The ASF licenses this file to You under the Apache License, Version 2.0
// (the "License"); you may not use this file except in compliance with
// the License.  You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go. DO NOT EDIT.
// source: beam_provision_api.proto

/*
Package org_apache_beam_fn_v1 is a generated protocol buffer package.

It is generated from these files:
	beam_provision_api.proto

It has these top-level messages:
	GetProvisionInfoRequest
	GetProvisionInfoResponse
	ProvisionInfo
*/
package org_apache_beam_fn_v1

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import google_protobuf "github.com/golang/protobuf/ptypes/struct"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// A request to get the provision info of a SDK harness worker instance.
type GetProvisionInfoRequest struct {
}

func (m *GetProvisionInfoRequest) Reset()                    { *m = GetProvisionInfoRequest{} }
func (m *GetProvisionInfoRequest) String() string            { return proto.CompactTextString(m) }
func (*GetProvisionInfoRequest) ProtoMessage()               {}
func (*GetProvisionInfoRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

// A response containing the provision info of a SDK harness worker instance.
type GetProvisionInfoResponse struct {
	Info *ProvisionInfo `protobuf:"bytes,1,opt,name=info" json:"info,omitempty"`
}

func (m *GetProvisionInfoResponse) Reset()                    { *m = GetProvisionInfoResponse{} }
func (m *GetProvisionInfoResponse) String() string            { return proto.CompactTextString(m) }
func (*GetProvisionInfoResponse) ProtoMessage()               {}
func (*GetProvisionInfoResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *GetProvisionInfoResponse) GetInfo() *ProvisionInfo {
	if m != nil {
		return m.Info
	}
	return nil
}

// Runtime provisioning information for a SDK harness worker instance,
// such as pipeline options, resource constraints and other job metadata
type ProvisionInfo struct {
	// (required) The job ID.
	JobId string `protobuf:"bytes,1,opt,name=job_id,json=jobId" json:"job_id,omitempty"`
	// (required) The job name.
	JobName string `protobuf:"bytes,2,opt,name=job_name,json=jobName" json:"job_name,omitempty"`
	// (required) Pipeline options. For non-template jobs, the options are
	// identical to what is passed to job submission.
	PipelineOptions *google_protobuf.Struct `protobuf:"bytes,3,opt,name=pipeline_options,json=pipelineOptions" json:"pipeline_options,omitempty"`
}

func (m *ProvisionInfo) Reset()                    { *m = ProvisionInfo{} }
func (m *ProvisionInfo) String() string            { return proto.CompactTextString(m) }
func (*ProvisionInfo) ProtoMessage()               {}
func (*ProvisionInfo) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *ProvisionInfo) GetJobId() string {
	if m != nil {
		return m.JobId
	}
	return ""
}

func (m *ProvisionInfo) GetJobName() string {
	if m != nil {
		return m.JobName
	}
	return ""
}

func (m *ProvisionInfo) GetPipelineOptions() *google_protobuf.Struct {
	if m != nil {
		return m.PipelineOptions
	}
	return nil
}

func init() {
	proto.RegisterType((*GetProvisionInfoRequest)(nil), "org.apache.beam.fn.v1.GetProvisionInfoRequest")
	proto.RegisterType((*GetProvisionInfoResponse)(nil), "org.apache.beam.fn.v1.GetProvisionInfoResponse")
	proto.RegisterType((*ProvisionInfo)(nil), "org.apache.beam.fn.v1.ProvisionInfo")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for ProvisionService service

type ProvisionServiceClient interface {
	// Get provision information for the SDK harness worker instance.
	GetProvisionInfo(ctx context.Context, in *GetProvisionInfoRequest, opts ...grpc.CallOption) (*GetProvisionInfoResponse, error)
}

type provisionServiceClient struct {
	cc *grpc.ClientConn
}

func NewProvisionServiceClient(cc *grpc.ClientConn) ProvisionServiceClient {
	return &provisionServiceClient{cc}
}

func (c *provisionServiceClient) GetProvisionInfo(ctx context.Context, in *GetProvisionInfoRequest, opts ...grpc.CallOption) (*GetProvisionInfoResponse, error) {
	out := new(GetProvisionInfoResponse)
	err := grpc.Invoke(ctx, "/org.apache.beam.fn.v1.ProvisionService/GetProvisionInfo", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ProvisionService service

type ProvisionServiceServer interface {
	// Get provision information for the SDK harness worker instance.
	GetProvisionInfo(context.Context, *GetProvisionInfoRequest) (*GetProvisionInfoResponse, error)
}

func RegisterProvisionServiceServer(s *grpc.Server, srv ProvisionServiceServer) {
	s.RegisterService(&_ProvisionService_serviceDesc, srv)
}

func _ProvisionService_GetProvisionInfo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetProvisionInfoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ProvisionServiceServer).GetProvisionInfo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/org.apache.beam.fn.v1.ProvisionService/GetProvisionInfo",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ProvisionServiceServer).GetProvisionInfo(ctx, req.(*GetProvisionInfoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _ProvisionService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "org.apache.beam.fn.v1.ProvisionService",
	HandlerType: (*ProvisionServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetProvisionInfo",
			Handler:    _ProvisionService_GetProvisionInfo_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "beam_provision_api.proto",
}

func init() { proto.RegisterFile("beam_provision_api.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 284 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x91, 0xcf, 0x4b, 0xc3, 0x30,
	0x14, 0xc7, 0xa9, 0x3f, 0xa6, 0x46, 0xc5, 0x12, 0x18, 0xeb, 0x86, 0x07, 0x29, 0x0a, 0x9e, 0x52,
	0x9c, 0x17, 0xaf, 0xf6, 0x22, 0xbb, 0xa8, 0x74, 0xde, 0x4b, 0xd2, 0xbd, 0xd6, 0x94, 0x35, 0x2f,
	0x36, 0x69, 0xff, 0x03, 0xf1, 0xdf, 0x96, 0xa5, 0x74, 0x30, 0xdd, 0x60, 0xd7, 0xf7, 0x3e, 0xdf,
	0x97, 0xf7, 0x79, 0x21, 0x81, 0x00, 0x5e, 0xa5, 0xba, 0xc6, 0x56, 0x1a, 0x89, 0x2a, 0xe5, 0x5a,
	0x32, 0x5d, 0xa3, 0x45, 0x3a, 0xc4, 0xba, 0x60, 0x5c, 0xf3, 0xec, 0x13, 0xd8, 0x0a, 0x62, 0xb9,
	0x62, 0xed, 0xc3, 0xe4, 0xba, 0x40, 0x2c, 0x96, 0x10, 0x39, 0x48, 0x34, 0x79, 0x64, 0x6c, 0xdd,
	0x64, 0xb6, 0x0b, 0x85, 0x63, 0x32, 0x7a, 0x01, 0xfb, 0xde, 0x8f, 0x9b, 0xa9, 0x1c, 0x13, 0xf8,
	0x6a, 0xc0, 0xd8, 0xf0, 0x83, 0x04, 0xff, 0x5b, 0x46, 0xa3, 0x32, 0x40, 0x9f, 0xc8, 0x91, 0x54,
	0x39, 0x06, 0xde, 0x8d, 0x77, 0x7f, 0x3e, 0xbd, 0x65, 0x5b, 0x9f, 0x66, 0x9b, 0x59, 0x97, 0x08,
	0xbf, 0x3d, 0x72, 0xb9, 0x51, 0xa7, 0x43, 0x32, 0x28, 0x51, 0xa4, 0x72, 0xe1, 0xa6, 0x9d, 0x25,
	0xc7, 0x25, 0x8a, 0xd9, 0x82, 0x8e, 0xc9, 0xe9, 0xaa, 0xac, 0x78, 0x05, 0xc1, 0x81, 0x6b, 0x9c,
	0x94, 0x28, 0x5e, 0x79, 0x05, 0x34, 0x26, 0xbe, 0x96, 0x1a, 0x96, 0x52, 0x41, 0x8a, 0xda, 0x4a,
	0x54, 0x26, 0x38, 0x74, 0x9b, 0x8c, 0x58, 0x67, 0xcb, 0x7a, 0x5b, 0x36, 0x77, 0xb6, 0xc9, 0x55,
	0x1f, 0x78, 0xeb, 0xf8, 0xe9, 0x8f, 0x47, 0xfc, 0xf5, 0x1e, 0x73, 0xa8, 0x5b, 0x99, 0x01, 0x35,
	0xc4, 0xff, 0xab, 0x4c, 0xd9, 0x0e, 0xb9, 0x1d, 0x67, 0x9b, 0x44, 0x7b, 0xf3, 0xdd, 0x2d, 0xe3,
	0x3b, 0xb2, 0xfd, 0xe7, 0xe2, 0x8b, 0x35, 0xff, 0xac, 0xa5, 0x18, 0x38, 0xa5, 0xc7, 0xdf, 0x00,
	0x00, 0x00, 0xff, 0xff, 0x97, 0x2b, 0xbd, 0x57, 0x01, 0x02, 0x00, 0x00,
}
